//========================================================
// xklotho.cpp  9.7.2000
// 
// To compile:
// Make 
// oder
// g++ -o xklotho xklotho.cpp -L/usr/X11R6/lib -lX11 -lm
// To run:
//   ./xklotho
// 

/*
  bash-2.03# time ./xklotho
  Keypress detected
  real    0m1.876s
  user    0m1.780s
  sys     0m0.010s
  bash-2.03# 

*/
//==============================================================
//#include <iostream.h>
#include <iostream>
#include <stdio.h>      // Need sprintf()
#include <stdlib.h>     // Need exit()
#include <string.h>     // Need strlen()
#include <math.h>

#include <X11/Xlib.h>   // Most X programs need these headers
#include <X11/Xutil.h>
#include <X11/Xos.h>

#define  vt pt                      // vector wird durch point ersetzt 

Display *display;       // X server display structure

float xmin,xmax,ymin,ymax,kx,ky; 

 
// structures als typedefs 
typedef struct punkt_typ 
	{ 
	  float x; 
	  float y; 
	} pt, *ptptr;               // neuer Typname = pt und Zeiger- 
				    // definition auf Typ pt 
 
typedef struct punktint_typ 
	{ 
	  int x; 
	  int y; 
	} ptint, *ptintptr;         // neuer Typname = ptint und Zeigerdef. 
				    // auf Typ ptint 
 
// globals 
  
  float scrfac;                     // Screenfaktor 
  int xasp, yasp;                   // Aspekt 
  int col;                          // Farbe 
  int maxxscr,maxyscr,maxcolor;     // Hardwarekoordinaten des Schirms 
				    // Punkte: 
  pt scro;                          // Ursprung = screen origin Gleitkomma ! 
  vt scru;                          // Umrechnungsfaktor ScrU.X ScrU.Y 
  float xl,yl;                      // Weltfensterlaenge und -breite 
  float xscrl,yscrl;                // Schirmfensterlaenge und -breite 
				    // in Gleitkomma 
				    // Intervalle: durch 2 Punkte gegeben 
				    // 1. links unten  2. rechts oben 
				    // allgem. Gleitkommaintervall: 
  pt wi[2];	                    // Weltintervall, also tatsaechlicher 
				    // Darstellungsbereich 
				    // allgem. Ganzzahlintervall: 
  ptint iscr[2];        	    // iscr = benutzte Bildschirmbereich 
				    // = viewport meist ganzer Bildschirm 
  ptint iscr2d[2];		    // = Bild des Weltintervalls am Schirm 
  // globals 
   pt p1,p2; 


Window win;
GC gc;

int intWidth = 640; 
int intHeight = 480; 
#define MAXCOLORS 16     // Number of colors in following arrays
// ForrestGreen NavyBlue gray0 DimGray AntiqueWhite  gray0 bis gray100
const char *Roy_G_Biv[] = {
  "Red",            // 0
  "Orange",         // 1
  "LightBlue",      // 2
  "Yellow",         // 3
  "Blue",           // 4
  "Violet",         // 5 Indigo 
  "DarkViolet",     // 6 Violet
  "NavyBlue",       // 7
  "gray0",          // 8
  "DarkBlue",       // 9
  "gray12",         // 10    dunkel
  "gray25",         // 11
  "gray40",         // 12
  "gray60",         // 13 
  "gray80",         // 14
  "gray90"          // 15     hell
};

unsigned long colors[ MAXCOLORS ];

// prototypes 
void GetColors(unsigned long intDefaultColor);
void grafikein(); 
void grafikaus(); 
void pt_festlegen(float x, float y, pt *p); 
void ptint_festlegen(int x, int y, ptint *p); 
void weltgrenzen_festlegen(pt eins, pt zwei); 
void viewport_festlegen(ptint eins, ptint zwei); 
void parametertransformationscr(float faktor, pt m); 
void transformation(pt p, ptint *pscr); 
void drawpt(pt p, int col); 
void drawline(pt p1, pt p2); 
// prototypes 
void vorbereitung(); 
void beschriftung(pt focus, float zoom); 
int klothoide();
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

int main()
{
  // Attempt to extablish communications with the X Server
  //
  display = XOpenDisplay(NULL);
  if (display == NULL) {
    std::cerr << "Failure connecting to X Server";
    printf("Failure connecting to X Server");
    exit(1);
  }

  // Calculate window's dimensions and position
  //
  int intScreenNum = DefaultScreen(display);
  int intDisplayWidth = DisplayWidth(display, intScreenNum);
  int intDisplayHeight = DisplayHeight(display, intScreenNum);
                              // intDisplayWidth / 3;   
                              //intDisplayHeight / 4;
  int intXPos = 0;
  int intYPos = 0;

  // Get the most basic of colors (black and white)
  //
  int intBlackColor, intWhiteColor;
  intBlackColor = BlackPixel(display, DefaultScreen(display));
  intWhiteColor = WhitePixel(display, DefaultScreen(display));

  // Create window (this does not make it visible)
  //Window 
  win =
  XCreateSimpleWindow(
    display,                         // X server display struct
    DefaultRootWindow(display),      // Parent window
    intXPos, intYPos,                // Position
    intWidth, intHeight,             // Window width & height
    0,                               // Border width (default)
    intBlackColor, intWhiteColor);   // Background, foreground 

  // Assign a name for the window title bar (probably)
  //
  XStoreName(display, win, "natuerliche Gleichung: ");

  // Create variables needed for XAllocNamedColor()
  //
  Colormap colormap = DefaultColormap(display, intScreenNum);
  const char * colorname = "NavyBlue"; 
  // ForrestGreen NavyBlue gray0 DimGray AntiqueWhite  gray0 bis gray100
  XColor screenColor, exactColor;
  GetColors(intBlackColor);
  // Allocate color. Exit if operation fails.
  //
  if (!XAllocNamedColor(display, colormap, colorname, 
			&screenColor, &exactColor)) {
    std::cerr << "Cannot allocate color " << colorname << std::endl;
    printf("Cannot allocate color");
    exit(1);
  }

  // Create a graphics context for our window
  //
  XGCValues gc_values;
  unsigned long gc_mask = GCForeground | GCLineWidth;
  gc_values.foreground = screenColor.pixel;
  gc_values.line_width = 1;
  //GC 
  gc = XCreateGC(display, win, gc_mask, &gc_values);

  //  Alternative for a default GC
  //  GC gc = XCreateGC(display, win, 0, NULL);
  //  XSetForeground(display, gc, screenColor.pixel);

  // Map the window to the display
  // Window is visible when first Expose event is received
  //
  XMapWindow(display, win);

  // Specify the types of events we want to receive
  //
  XSelectInput(display, win, 
    ExposureMask | KeyPressMask | ButtonPressMask | ButtonReleaseMask | Button1MotionMask);

  // Mouse movement and button event loop
  // with double-clicking.
  //
  bool done = false;
  bool mouseDown = false;
  int x1, x2, y1, y2;
  x1 = 30; y1 = 22; x2 = 598; y2 = 400;
  Time lastTime = 0;
  XEvent event;
  while (!done) {
    XNextEvent(display, &event);
    switch (event.type) {
      case ButtonPress:
        x1 = event.xbutton.x;
        y1 = event.xbutton.y;
        mouseDown = true;
        break;
      case ButtonRelease:
        if (event.xbutton.time - lastTime < 250) 
          XClearWindow(display, win);
        else
          lastTime = event.xbutton.time;
        mouseDown = false;  klothoide();
        break; 
      case MotionNotify:
	if (mouseDown) {
          x2 = event.xbutton.x;
          y2 = event.xbutton.y;
	  XDrawLine(display, win, gc, x1, y1, x2, y2);
          XDrawPoint(display, win, gc, x2, y2);
	  x1 = x2;
	  y1 = y2;
	}
	break; 
      case Expose:
        // Should redraw lines here
         
  // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX   
       
        klothoide();       
             
        break;

   // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX 
     case KeyPress:
       std::cout << "Keypress detected" << std::endl;
       done = true;   // Exit on any keypress
       break;
    }
  }

 

  // Disconnect X server connection and exit.
  // (Program may never get to here)
  //
  XCloseDisplay(display);
  return 0;
}
 
// Allocate global colors array using intDefaultColor if a 
// named color cannot be allocated for any reason.
void GetColors(unsigned long intDefaultColor)
{
  Colormap colormap = DefaultColormap(display, DefaultScreen(display));
  XColor screenColor, exactColor;

  for (int i = 0; i < MAXCOLORS; i++) {
    if (!XAllocNamedColor(display, colormap, Roy_G_Biv[i], 
			  &screenColor, &exactColor)) {
      std::cerr << "Color " << Roy_G_Biv[i] << " unavailable" << std::endl;
      std::cerr << "using 'black' in its place." << std::endl;
      colors[i] = intDefaultColor;
    } else {
      colors[i] = screenColor.pixel;
    }
  }      
} 
  
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// juni 2000 endlgraphik auf linux
 

// functions 
void grafikein() 
{  
   maxxscr = intWidth; 
   maxyscr = intHeight; 
   scrfac = 1.0;    
} 
 
void grafikaus() 
{  
  ptint pscr1,pscr2;
  XSetForeground(display, gc, colors[2]);
  pscr1.x = intWidth - 10; pscr1.y = intHeight - 10;
  pscr2.x = intWidth - 10; pscr2.y = intHeight - 30;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y); 
  pscr1.x = intWidth - 10; pscr1.y = intHeight - 30;
  pscr2.x = intWidth - 30; pscr2.y = intHeight - 30;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y);
  pscr1.x = intWidth - 30; pscr1.y = intHeight - 30;
  pscr2.x = intWidth - 30; pscr2.y = intHeight - 10;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y);
  pscr1.x = intWidth - 30; pscr1.y = intHeight - 10;
  pscr2.x = intWidth - 10; pscr2.y = intHeight - 10;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y);
  pscr1.x = intWidth - 10; pscr1.y = intHeight - 10;
  pscr2.x = intWidth - 30; pscr2.y = intHeight - 30;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y);
  pscr1.x = intWidth - 30; pscr1.y = intHeight - 10;
  pscr2.x = intWidth - 10; pscr2.y = intHeight - 30;
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y);
  XSetForeground(display, gc, colors[8]);
} 
 
void pt_festlegen(float x, float y, pt *p) 
{ 
  p->x = x; 
  p->y = y; 
} 
 
void ptint_festlegen(int x, int y, ptint *p) 
{ 
  p->x = x; 
  p->y = y; 
} 
 
void weltgrenzen_festlegen(pt m) 
{ 
  wi[0].x = m.x - xl/2.0; wi[0].y = m.y - yl/2.0;    // 1. Punkt links unten 
  wi[1].x = m.x + xl/2.0; wi[1].y = m.y + yl/2.0 ;   // 2. Punkt rechts oben 
} 
 
void viewport_festlegen(ptint loscr, ptint ruscr)     // links oben screen 
{                                                     // rechts unten screen 
  iscr[0].x = loscr.x;  iscr[0].y = loscr.y;          // y wird von oben 
  iscr[1].x = ruscr.x;  iscr[1].y = ruscr.y;          // herunter gezaehlt ! 
} 
 
void parametertransformationscr(float zoom, pt focus) 
{ 
  xscrl = iscr[1].x - iscr[0].x; yscrl = iscr[0].y - iscr[1].y; 
  if(scrfac <= 1.0) 
  { 
     scru.y = zoom; 
     yl = yscrl/scru.y; xl = xscrl/yscrl*scrfac*yl; 
     scru.x = scru.y/scrfac; 
     iscr2d[0].x = iscr[0].x + (int)(floor((xscrl - scru.x*xl)/2.0+0.5)); 
     iscr2d[0].y = iscr[0].y; 
     iscr2d[1].x = iscr[1].x - (int)(floor((xscrl - scru.x*xl)/2.0+0.5)); 
     iscr2d[1].y = iscr[1].y; 
   } 
   else 
   { 
     scru.x = zoom; 
     xl = xscrl/scru.x; yl = yscrl/xscrl/scrfac*xl; 
     scru.y = scru.x*scrfac; 
     iscr2d[0].x = iscr[0].x; 
     iscr2d[0].y = iscr[0].y - (int)(floor((yscrl - scru.y*yl)/2.0+0.5)); 
     iscr2d[1].x = iscr[1].x; 
     iscr2d[1].y = iscr[1].y + (int)(floor((yscrl - scru.y*yl)/2.0+0.5)); 
  } 
  weltgrenzen_festlegen(focus); 
  scro.x = iscr2d[0].x + floor(scru.x*(-wi[0].x)+0.5); 
  scro.y = iscr2d[0].y - floor(scru.y*(-wi[0].y)+0.5); 
} 
 
void transformation(pt p, ptint *pscr) 
{ 
  pscr->x = (int)((scro.x + scru.x * p.x )); 
  pscr->y = (int)((scro.y - scru.y * p.y )); 
} 
 
void drawpt(pt p, int col) 
{ 
  ptint pscr; 
  if(p.x < wi[0].x) p.x = wi[0].x;                     // Clipping in world 
  if(p.x > wi[1].x) p.x = wi[1].x; 
  if(p.y < wi[0].y) p.y = wi[0].y; 
  if(p.y > wi[1].y) p.y = wi[1].y; 
  transformation(p, &pscr); 
  XDrawPoint(display, win, gc, pscr.x,pscr.y); 
}
 
void drawline(pt p1, pt p2) 
{ 
  ptint pscr1,pscr2; 
  if(p1.x < wi[0].x) p1.x = wi[0].x;                   // Clipping in world 
  if(p1.x > wi[1].x) p1.x = wi[1].x; 
  if(p1.y < wi[0].y) p1.y = wi[0].y; 
  if(p1.y > wi[1].y) p1.y = wi[1].y; 
  if(p2.x < wi[0].x) p2.x = wi[0].x; 
  if(p2.x > wi[1].x) p2.x = wi[1].x; 
  if(p2.y < wi[0].y) p2.y = wi[0].y; 
  if(p2.y > wi[1].y) p2.y = wi[1].y;   
  transformation(p1, &pscr1); 
  transformation(p2, &pscr2); 
  XDrawLine(display, win,gc, pscr1.x, pscr1.y, pscr2.x, pscr2.y); 
}



 


 
int klothoide() 
{ 
   pt p1,p2; 
   float s,sg,sumx,sumy,x,y,dels,delsg,a; 
   float salt,sumxalt,sumyalt; 
   vorbereitung(); 
   
const char * colorname = "red"; 
  // ForrestGreen NavyBlue gray0 DimGray AntiqueWhite  gray0 bis gray100
  XColor screenColor, exactColor;
   p1.x = 0.0; p1.y = 0.0; p2.x = 0.0; p2.y = 0.0; 
   drawline(p1,p2); 
   
   dels = 0.0001; delsg = 0.1;  a = 10.0; 
   sumxalt = 0.0; 
   sumyalt = 0.0; 
   salt = 0.0; 
   sg = 0.0; 
   while(sg <= 100.0) 
   { 
     sumx = sumxalt; 
     sumy = sumyalt; 
     s = salt; 
     while(s <= sg) 
     { 
       sumx = sumx + cos(s*s/(2.0*a*a))*dels; 
       sumy = sumy + sin(s*s/(2.0*a*a))*dels; 
       s = s + dels; 
     } 
     salt = s; 
     x = sumx; y = sumy; 
     p1.x = sumxalt; p1.y = sumyalt; p2.x = x; p2.y = y; 
     drawline(p1,p2); 
     sumxalt = sumx; 
     sumyalt = sumy; 
     sg = sg + delsg; 
  } 
  sumxalt = 0.0; 
  sumyalt = 0.0; 
  salt = 0.0; 
  sg = 0.0; 
  while(sg <= 100.0) 
  { 
    sumx = sumxalt; 
    sumy = sumyalt; 
    s = salt; 
    while(s <= sg) 
    { 
       sumx = sumx - cos(s*s/(2.0*a*a))*dels; 
       sumy = sumy - sin(s*s/(2.0*a*a))*dels; 
       s = s + dels; 
    } 
    salt = s; 
    x = sumx; y = sumy; 
    p1.x = sumxalt; p1.y = sumyalt; p2.x = x; p2.y = y; 
    drawline(p1,p2); 
    sumxalt = sumx; 
    sumyalt = sumy; 
    sg = sg + delsg; 
  } 
  grafikaus(); 
  return 0; 
} 
 
 
// functions 
void vorbereitung() 
{ 
   pt p1,p2; 
   pt focus;                                 // Interessenzentrum = Mittel 
					     // punkt des Weltfensters ist 
					     // nicht der Koo.ursprung ! 
   float zoom;                               // Vergroesserungsfaktor 
					     // grosser Wert = vergroessern = 
					     // hineinzoomen. Der Bild- 
					     // ausschnitt wird kleiner. 
   grafikein(); 
   ptint luscr = { 0,maxyscr}; 
   ptint roscr = { maxxscr, 0}; 
   viewport_festlegen(luscr, roscr); 
   zoom = 15.1; focus.x = 0.2; focus.y = -0.3; 
   parametertransformationscr(zoom, focus); 
 
   XSetForeground(display, gc, colors[2]); 
   p1.x = wi[0].x; p1.y = 0.0;                                // X-Achse 
   p2.x = wi[1].x; p2.y = 0.0; 
   drawline(p1, p2); 
   p1.x = 0.0; p1.y = wi[0].y;                                // Y Achse 
   p2.x = 0.0; p2.y = wi[1].y; 
   drawline(p1, p2); 
   
   p1.x = wi[0].x; p1.y = wi[1].y;                            // oberer Rand 
   p2.x = wi[1].x; p2.y = wi[1].y; 
   drawline(p1, p2); 
   p1.x = wi[0].x; p1.y = wi[0].y;                            // unterer Rand 
   p2.x = wi[1].x; p2.y = wi[0].y; 
   drawline(p1, p2); 
   p1.x = wi[1].x; p1.y = wi[0].y;                            // rechter Rand 
   p2.x = wi[1].x; p2.y = wi[1].y; 
   drawline(p1, p2); 
   p1.x = wi[0].x; p1.y = wi[0].y;                            // linker Rand 
   p2.x = wi[0].x; p2.y = wi[1].y; 
   drawline(p1, p2); 
   XSetForeground(display, gc, colors[8]); 
   beschriftung( focus, zoom); 
} 
 
 
void beschriftung(pt focus, float zoom) 
{ 
 const char *ueberschrift = {"Klothoide:"};
 int xpos,ypos;                           // X Y Position des auszugebenden 
					  // Strings 
   int ndig = 5;                          // Stellenanzahl= ndigits 
   char slash[6] = {"  /  "};
   char leer[5] = {""};
   char zeile[80] = {""};
   char wi0x[10];                         // Weltintervall  links unten x 
   char wi0y[10];                         //                links unten y 
   char wi1x[10];                         //                rechts oben x 
   char wi1y[10];                         //                rechts oben y 
   char focusx[10];                       // Focusstring
   char focusy[10];
   char zooms[10];
   gcvt(wi[0].x, ndig, wi0x);             // in strings wandeln 
   gcvt(wi[0].y, ndig, wi0y); 
   gcvt(wi[1].x, ndig, wi1x); 
   gcvt(wi[1].y, ndig, wi1y); 
   gcvt(focus.x, ndig, focusx);             // in strings wandeln 
   gcvt(focus.y, ndig, focusy);
   gcvt(zoom, ndig, zooms);
   xpos = 4; ypos = 10; 
   XDrawString(display, win, gc, xpos, ypos, ueberschrift,strlen(ueberschrift)); 
   ypos += 10;
   strcat(zeile,"Weltfenster links unten: ");
   strcat(zeile,wi0x); strcat(zeile,slash); strcat(zeile,wi0y);
   XDrawString(display, win, gc, xpos, ypos, zeile,strlen(zeile));
   ypos += 10; strcpy(zeile,"");
   strcat(zeile,"Weltfenster rechts oben: ");
   strcat(zeile,wi1x); strcat(zeile,slash); strcat(zeile,wi1y);
   XDrawString(display, win, gc, xpos, ypos, zeile,strlen(zeile));
   ypos += 10; strcpy(zeile,"");
   strcat(zeile,"Fokuspunkt: ");
   strcat(zeile,focusx); strcat(zeile,slash); strcat(zeile,focusy);
   XDrawString(display, win, gc, xpos, ypos, zeile,strlen(zeile));
   ypos += 10; strcpy(zeile,"");
   strcat(zeile,"Zoomfaktor: ");
   strcat(zeile,zooms);
   XDrawString(display, win, gc, xpos, ypos, zeile,strlen(zeile));
}


